





AutoDrive = {}; 
AutoDrive.Version = "0.4.1";
AutoDrive.config_changed = false;

local AutoDrive_directory = g_currentModDirectory;

function AutoDrive:prerequisitesPresent(specializations)
    return true;
end;

function AutoDrive:delete()	

end;

function AutoDrive:MarkChanged()
	AutoDrive.config_changed = true;
end;

function AutoDrive:GetChanged()
	return AutoDrive.config_changed;
end;

function AutoDrive:loadMap(name)
	self.loadedMap = name;
	if name == "data/maps/map01.i3d" then
	 self.loadedMap = "Goldcrest";
	 g_currentMission.autoLoadedMap = "Goldcrest";
	end;
	--print("map " .. self.loadedMap .. " was loaded");
end;

function AutoDrive:deleteMap()
	
	--print("delete map called");
	
	if AutoDrive:GetChanged() == true then
	
		if g_currentMission.AutoDrive.adXml ~= nil then
			local adXml = g_currentMission.AutoDrive.adXml;
			
			setXMLString(adXml, "AutoDrive.Version", AutoDrive.Version);		
			
			for i in pairs(g_currentMission.AutoDrive.mapWayPoints) do
				
				setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".id", g_currentMission.AutoDrive.mapWayPoints[i].id);
				for i2 in pairs(g_currentMission.AutoDrive.mapWayPoints[i].out) do
					setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".out" .. i2, g_currentMission.AutoDrive.mapWayPoints[i].out[i2]);
				end;
				local incoming_counter = 1;
				for i2 in pairs(g_currentMission.AutoDrive.mapWayPoints) do
					for i3 in pairs(g_currentMission.AutoDrive.mapWayPoints[i2].out) do
						if g_currentMission.AutoDrive.mapWayPoints[i2].out[i3] == g_currentMission.AutoDrive.mapWayPoints[i].id then
							setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".incoming" .. incoming_counter, g_currentMission.AutoDrive.mapWayPoints[i2].id);
							incoming_counter = incoming_counter + 1;
						end;
					end;
				end;
				
				for i2 in pairs(g_currentMission.AutoDrive.mapWayPoints[i].out_cost) do
					setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".out_cost" .. i2, g_currentMission.AutoDrive.mapWayPoints[i].out_cost[i2]);
				end;
				local marker_counter = 1;
				for i2 in pairs(g_currentMission.AutoDrive.mapWayPoints[i].marker) do
					setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp" .. i ..".marker" .. marker_counter .. ".id", g_currentMission.AutoDrive.mapWayPoints[i].marker[i2]);
					setXMLString(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".marker" .. marker_counter .. ".name", g_currentMission.AutoDrive.mapMarker[marker_counter].name);
					marker_counter = marker_counter + 1;
				end;
				
				setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".coords.x", g_currentMission.AutoDrive.mapWayPoints[i].x);			
				setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".coords.y", g_currentMission.AutoDrive.mapWayPoints[i].y);			
				setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. i ..".coords.z", g_currentMission.AutoDrive.mapWayPoints[i].z);
				
			end;
			
			for i in pairs(g_currentMission.AutoDrive.mapMarker) do
		
				setXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".mapmarker.mm".. i ..".id", g_currentMission.AutoDrive.mapMarker[i].id);
				setXMLString(adXml, "AutoDrive." .. self.loadedMap .. ".mapmarker.mm".. i ..".name", g_currentMission.AutoDrive.mapMarker[i].name);			
			
			end;
			
			saveXMLFile(adXml);
		end;
	end;
	
end;

function AutoDrive:load(xmlFile)
	if g_currentMission.AutoDrive == nil then
		print("not present");
		g_currentMission.AutoDrive = {};
		g_currentMission.AutoDrive.mapWayPoints = {};
		g_currentMission.AutoDrive.mapWayPointsCounter = 1;
		g_currentMission.AutoDrive.mapMarker = {};
		g_currentMission.AutoDrive.mapMarkerCounter = 0;
				
		--loading savefile
		local adXml;
		local path = getUserProfileAppPath();
		local file = path.."AutoDrive_config.xml";
		local tempXml = nil;
		
		if fileExists(file) then
			print("Loading xml file");
			adXml = loadXMLFile("AutoDrive_XML", file);--, "AutoDrive");
			
			local VersionCheck = getXMLString(adXml, "AutoDrive.version");
			if VersionCheck == nil or VersionCheck ~= AutoDrive.Version then
				path = getUserProfileAppPath();
				file = path .. "/mods/AutoDrive/AutoDrive_init_config.xml";
				
				print("Loading xml file from init config");
				tempXml = loadXMLFile("AutoDrive_XML_temp", file);--, "AutoDrive");
				--local tempstring = saveXMLFileToMemory(tempXml);
				--adXml = loadXMLFileFromMemory("AutoDrive_XML", tempstring);
				print("Finished loading xml from memory");
				
				AutoDrive:MarkChanged();
				
			end;
			
			--print("Finished loading xml");
				
		else --create std file instead:
			path = getUserProfileAppPath();
			file = path .. "/mods/AutoDrive/AutoDrive_init_config.xml";
			
			print("Loading xml file from init config");
			tempXml = loadXMLFile("AutoDrive_XML_temp", file);--, "AutoDrive");
			--local tempstring = saveXMLFileToMemory(tempXml);
			--adXml = loadXMLFileFromMemory("AutoDrive_XML", tempstring);
			print("Finished loading xml from memory");
			
			AutoDrive:MarkChanged();
			
			path = getUserProfileAppPath();
			file = path.."AutoDrive_config.xml";
			print("creating xml file at " .. file);
			adXml = createXMLFile("AutoDrive_XML", file, "AutoDrive");
			local savewaypoints = {};
			local savewaypoint1 = {x=1,y=2,z=3};
			local savewaypoint2 = {x=1,y=2,z=4};
			savewaypoints[1] = savewaypoint1;
			savewaypoints[2] = savewaypoint2;
			
			for _,wp in pairs(savewaypoints) do
				setXMLFloat(adXml, "AutoDrive.waypoints.test" .. _ ,wp.z);
			end;		
			
			
			
			saveXMLFile(adXml);
		end;
		
		local backupXml = false;
		if adXml ~= nil then
			--print("Loading waypoints");
			if tempXml ~= nil then
				print("Loading from init file");
				backupXml = true;
				path = getUserProfileAppPath();
				file = path .. "/mods/AutoDrive/AutoDrive_init_config.xml";
				adXml = loadXMLFile("AutoDrive_XML_temp", file);--, "AutoDrive");
			end;
			g_currentMission.AutoDrive.adXml = adXml;
			--print("retrieving waypoints");
			--print("map " .. g_currentMission.autoLoadedMap .. " waypoints are loaded");
			self.loadedMap = g_currentMission.autoLoadedMap;
			if g_currentMission.autoLoadedMap == "Goldcrest" then 
				local wp_counter = 1;
				local wp = {};
				wp.id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. wp_counter ..".id");
				
				while wp.id ~= nil do
					--print("wp id: " .. wp.id);
					wp.out = {};
					local out_counter = 1;
					local out_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".out" .. out_counter );
					while out_id ~= nil do
						--print("wp out: " .. out_id);				
						wp.out[out_counter] = out_id
						out_counter = out_counter + 1;
						out_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".out" .. out_counter );
					end;
					
					wp.incoming = {};
					local incoming_counter = 1;
					local incoming_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".incoming" .. incoming_counter );
					while incoming_id ~= nil do				
						--print("wp incoming: " .. incoming_id);
						wp.incoming[incoming_counter] = incoming_id
						incoming_counter = incoming_counter + 1;
						incoming_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".incoming" .. incoming_counter );
					end;
					
					wp.out_cost = {};
					local out_cost_counter = 1;
					local out_cost_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".out_cost" .. out_cost_counter );
					while out_cost_id ~= nil do					
						--print("wp out_cost: " .. out_cost_id);
						wp.out_cost[out_cost_counter] = out_cost_id
						out_cost_counter = out_cost_counter + 1;
						out_cost_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".out_cost" .. out_cost_counter );
					end;
					
					wp.x = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".coords.x");
					wp.y = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".coords.y");
					wp.z = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".coords.z");
					--print("wp coords: " .. wp.x .. "/" .. wp.y .. "/" .. wp.z);
					
					
					wp.marker = {};		
					--[[
					local marker_counter = 1;
					local marker_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".marker" .. marker_counter .. ".id" );
					local marker_name = getXMLString(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".marker" .. marker_counter .. ".name" );
					while marker_name ~= nil do					
						--print("wp out_cost: " .. out_cost_id);
						wp.marker[marker_name] = marker_id
						marker_counter = marker_counter + 1;
						marker_id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".marker" .. marker_counter .. ".id" );						
						marker_name = getXMLString(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp"..wp_counter..".marker" .. marker_counter .. ".name" );
					end;
					
					--]]
					
					g_currentMission.AutoDrive.mapWayPoints[wp_counter] = createNode(wp.id,wp.out,wp.incoming,wp.out_cost, wp.marker);
					g_currentMission.AutoDrive.mapWayPoints[wp_counter].x = wp.x;
					g_currentMission.AutoDrive.mapWayPoints[wp_counter].y = wp.y;
					g_currentMission.AutoDrive.mapWayPoints[wp_counter].z = wp.z;
					wp_counter = wp_counter + 1;
					wp.id = getXMLFloat(adXml, "AutoDrive." .. self.loadedMap .. ".waypoints.wp".. wp_counter ..".id");
				end;
				wp_counter = wp_counter - 1;
				
				--print("'wp: " ..wp_counter);
				
				if g_currentMission.AutoDrive.mapWayPoints[wp_counter] ~= nil then
					g_currentMission.AutoDrive.mapWayPointsCounter = wp_counter;
				end;
				
				local mapMarker = {};
				local mapMarkerCounter = 1;
				mapMarker.name = getXMLString(adXml,"AutoDrive." .. self.loadedMap ..".mapmarker.mm"..mapMarkerCounter..".name");
				
				while mapMarker.name ~= nil do
					mapMarker.id = getXMLFloat(adXml,"AutoDrive." .. self.loadedMap ..".mapmarker.mm"..mapMarkerCounter..".id");
					
					g_currentMission.AutoDrive.mapMarker[mapMarkerCounter] = mapMarker;
					mapMarker = nil;
					mapMarker = {};
					mapMarkerCounter = mapMarkerCounter + 1;	
					g_currentMission.AutoDrive.mapMarkerCounter = g_currentMission.AutoDrive.mapMarkerCounter + 1;
					mapMarker.name = getXMLString(adXml,"AutoDrive." .. self.loadedMap ..".mapmarker.mm"..mapMarkerCounter..".name");
				end;
				--[[
				for i in pairs(g_currentMission.AutoDrive.mapWayPoints) do
					print("wp.id: " .. g_currentMission.AutoDrive.mapWayPoints[i].id);
				end;
				--]]
			else
				print("AutoDrive: Waypoints and markers are not yet supported on this map - Try it on Goldcrest");
			end;
			
			--g_currentMission.AutoDrive.ad = {};
			--if self.ad == nil then
			--	self.ad = {};
			--end;
			--g_currentMission.AutoDrive.ad = self.ad;
			
			--checking if all ways are calculated correctly - if not, new shortest paths are generated
			--[[
			for i, point in pairs(g_currentMission.AutoDrive.mapWayPoints) do
				if i < 5000 then
					local done = true;
					for i2, marker in pairs(g_currentMission.AutoDrive.mapMarker) do
						if point.marker[marker.name] == nil then
							done = false;
						end;
					end;
					
					
					if not done then	
						print("Point " .. i .. " is not done yet");
						AutoDrive:dijkstra(g_currentMission.AutoDrive.mapWayPoints, point.id, "out");
						
					
						for i2, marker in pairs(g_currentMission.AutoDrive.mapMarker) do
							
							if point.marker[marker.name] == nil then
								local tempRoute = AutoDrive:shortestPath(g_currentMission.AutoDrive.mapWayPoints,self.ad.distance,self.ad.pre,point.id,marker.id);
							
								for i3 in pairs(tempRoute) do
									
									g_currentMission.AutoDrive.mapWayPoints[ self.ad.pre[tempRoute[i3].id] ].marker[marker.name] = tempRoute[i3].id;
									
								end;
							end;
						
						end;
					end;
				end;
			end;
			--]]
			
			
			for i, marker in pairs(g_currentMission.AutoDrive.mapMarker) do
				
				local tempAD = AutoDrive:dijkstra(g_currentMission.AutoDrive.mapWayPoints, marker.id,"incoming");
				
				for i2,point in pairs(g_currentMission.AutoDrive.mapWayPoints) do
							
					point.marker[marker.name] = tempAD.pre[point.id];
								
				end;
				
				
			end;
			
			
			if backupXml == true then
				--print("Switching back to correct xml");
				path = getUserProfileAppPath();
				file = path.."AutoDrive_config.xml";
				adXml = loadXMLFile("AutoDrive_XML", file);--, "AutoDrive");
				g_currentMission.AutoDrive.adXml = adXml;
			end;
			
		end;			
	end;
	
end;

function AutoDrive:dijkstra(Graph,start,setToUse)
	
	--init
	--initdijkstra(Graph,Start,distance,pre,Q);
	if self.ad == nil then
		self.ad = {};--g_currentMission.AutoDrive.ad;
	end;
	
	self.ad.Q = AutoDrive:graphcopy(Graph);
	self.ad.distance = {};
	self.ad.pre = {};
	for i in pairs(Graph) do
		self.ad.distance[i] = -1;
		self.ad.pre[i] = -1;
	end;
	self.ad.distance[start] = 0;
	for i in pairs(self.ad.Q[start][setToUse]) do
		--print("out of start: " .. self.ad.Q[start][setToUse][i] );
		self.ad.distance[self.ad.Q[start][setToUse][i]] = 1 --self.ad.Q[start]["out_cost"][i];
		self.ad.pre[self.ad.Q[start][setToUse][i]] = start;
	end;
	--init end
	
	while next(self.ad.Q,nil) ~= nil do
		local shortest = 10000000;
		local shortest_id = -1;
		for i in pairs(self.ad.Q) do
			if self.ad.distance[self.ad.Q[i]["id"]] < shortest and self.ad.distance[self.ad.Q[i]["id"]] ~= -1 then
				shortest = self.ad.distance[self.ad.Q[i]["id"]];
				shortest_id = self.ad.Q[i]["id"];
			end;
		end;
		
		if shortest_id == -1 then
			self.ad.Q = {};
		else
			for i in pairs(self.ad.Q[shortest_id][setToUse]) do
				local inQ = false;
				for i2 in pairs(self.ad.Q) do
					if self.ad.Q[i2]["id"] ==  self.ad.Q[shortest_id][setToUse][i] then
						inQ = true;
					end;
				end;
				if inQ == true then
					--distanceupdate
					local alternative = shortest + 1 --self.ad.Q[shortest_id]["out_cost"][i];
					if alternative < self.ad.distance[self.ad.Q[shortest_id][setToUse][i]] or self.ad.distance[self.ad.Q[shortest_id][setToUse][i]] == -1 then
						--print("found shorter alternative for " .. Q[shortest_id][setToUse][i] .. " via " .. shortest_id .. " new distance: " .. alternative );
						self.ad.distance[self.ad.Q[shortest_id][setToUse][i]] = alternative;
						self.ad.pre[self.ad.Q[shortest_id][setToUse][i]] = shortest_id;
					end;
				end;			
			end;
			
			self.ad.Q[shortest_id] = nil;
		end;
		
	end;	
	--print("distance to 3: " .. self.ad.distance[3]);	
	
	for i in pairs(self.ad.pre) do
		--print("pre "..i .. " = ".. self.ad.pre[i]);
	end;
	
	--shortestPath(Graph,self.ad.distance,self.ad.pre,1,3);
	
	return self.ad;
	
end;

function AutoDrive:graphcopy(Graph)
	local Q = {};
	--print("Graphcopy");
	for i in pairs(Graph) do
		--print ("i = " .. i );
		local id = Graph[i]["id"];
		--print ("id = " .. id );
		local out = {};
		local incoming = {};
		local out_cost = {};
		local marker = {};
		
		--print ("out:");
		for i2 in pairs(Graph[i]["out"]) do
			out[i2] = Graph[i]["out"][i2];
			--print(""..i2 .. " : " .. out[i2]);
		end;
		--print("incoming");
		for i3 in pairs(Graph[i]["incoming"]) do
			incoming[i3] = Graph[i]["incoming"][i3];
		end;
		for i4 in pairs(Graph[i]["out_cost"]) do
			out_cost[i4] = Graph[i]["out_cost"][i4];
		end;
		
		
		for i5 in pairs(Graph[i]["marker"]) do
			marker[i5] = Graph[i]["marker"][i5];
		end;
		
		
		Q[i] = createNode(id,out,incoming,out_cost, marker);
		
		Q[i].x = Graph[i].x;
		Q[i].y = Graph[i].y;
		Q[i].z = Graph[i].z;
		
	end;

	return Q;
end;

function createNode(id,out,incoming,out_cost, marker)
	local p = {};
	p["id"] = id;
	p["out"] = out;
	p["incoming"] = incoming;
	p["out_cost"] = out_cost;
	p["marker"] = marker;
	--p["coords"] = coords;
	
	return p;
end

function AutoDrive:FastShortestPath(Graph,start,markerName, markerID)
	
	local wp = {};
	local count = 1;
	local id = start;
	--print("searching path for start id: " .. id .. " and target: " .. markerName .. " id: " .. markerID);
	while id ~= -1 and id ~= nil do
		
		wp[count] = Graph[id];
		count = count+1;
		--print(""..wp[count-1]["id"]);
		if id == markerID then
			id = nil;
		else
			id = g_currentMission.AutoDrive.mapWayPoints[id].marker[markerName];
		end;
	end;
	
	local wp_copy = AutoDrive:graphcopy(wp);
	
	--print("shortest path to " .. markerName);
	--for i in pairs(wp) do
		--print(""..wp[i]["id"]);
	--end;
	
	return wp_copy;
end;

function AutoDrive:shortestPath(Graph,distance,pre,start,endNode)
	local wp = {};
	local count = 1;
	local id = Graph[endNode]["id"];
	
	while self.ad.pre[id] ~= -1 do
		for i in pairs(Graph) do
			if Graph[i]["id"] == id then
				wp[count] = Graph[i];  --todo: maybe create copy
			end;
		end;
		count = count+1;
		id = self.ad.pre[id];
	end;

	
	local wp_reversed = {};
	for i in pairs(wp) do
		wp_reversed[count-i] = wp[i];
	end;
	
	local wp_copy = AutoDrive:graphcopy(wp_reversed);
	
	--print("shortest path to " .. Graph[endNode]["id"]);
	for i in pairs(wp) do
		--print(""..wp[i]["id"]);
	end;
	
	return wp_copy;
	
end;

function init(self)
	local aNameSearch = {"vehicle.name." .. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle.storeData.name", "vehicle#type"};
	self.bDisplay = 1; 
	if self.ad == nil then
		self.ad = {};
	end;
	
	self.bLongFormat = 0; 
	self.nSubStringLength = 40; 
	self.bDarkColor = 0; 
	self.nDebugOutput = 0; 
	self.bActive = false;
	self.bRoundTrip = false;
	self.bReverseTrack = false;
	self.bDrivingForward = true;
	self.nTargetX = 0;
	self.nTargetZ = 0;
	self.bInitialized = false;
	self.ad.wayPoints = {};
	self.bcreateMode = false;
	self.nCurrentWayPoint = 0;
	self.nlastLogged = 0;
	self.nloggingInterval = 500;
	self.logMessage = "";
	self.nPrintTime = 3000;
	self.ntargetSelected = -1;
	self.bTargetMode = false;
	self.nMapMarkerSelected = -1;
	self.nSpeed = 40;
	self.bCreateMapPoints = false;
	self.bShowDebugMapMarker = false;
	self.nSelectedDebugPoint = -1;
	self.bShowSelectedDebugPoint = false;
	self.bChangeSelectedDebugPoint = false;
	self.DebugPointsIterated = {};
	self.sTargetSelected = "";
	self.bStopAD = false;
	self.bCreateMapMarker = false;
	
	if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) 
			orgSteerableLoad(self,xmlFile) 
			for nIndex,sXMLPath in pairs(aNameSearch) do 
				self.name = getXMLString(self.xmlFile, sXMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("UNKNOWN")
			end; 
		end
	
	end;
	self.moduleInitialized = true;
end;

function AutoDrive:mouseEvent(posX, posY, isDown, isUp, button)

end; 

function AutoDrive:keyEvent(unicode, sym, modifier, isDown) 
	--[[
	if self == g_currentMission.controlledVehicle then
		
		if isDown and sym == Input.KEY_up and bitAND(modifier, Input.MOD_CTRL) > 0 then 
			if self.bReverseTrack == false then
				self.bReverseTrack = true;
				--print("reverse track = true");
				self.printMessage = "Set to Reverse Track";
				self.nPrintTime = 3000;
			else
				self.bReverseTrack = false;	
				self.bDrivingForward = true;
				--print("reverse track = false");
				self.printMessage = "Disabled Reverse Track";
				self.nPrintTime = 3000;
			end;
			
		end; 
	
		if isDown and sym == Input.KEY_right and bitAND(modifier, Input.MOD_CTRL) > 0 then 
			if self.bRoundTrip == false then
				self.bRoundTrip = true;
				--print("roundTrip = true");
				self.printMessage = "Activated Round Trip";
				self.nPrintTime = 3000;
				
			else
				self.bRoundTrip = false;
				--print("roundTrip = false");
				self.printMessage = "Deactivated Round Trip";
				self.nPrintTime = 3000;
			end;
		end; 
		if isDown and sym == Input.KEY_left and bitAND(modifier, Input.MOD_CTRL) > 0 then
			if self.bcreateMode == false then 
				self.bcreateMode = true;				
				self.nCurrentWayPoint = 0;
				self.bActive = false;
				self.ad.wayPoints = {};
				self.printMessage = "Activated Recording Mode";
				self.nPrintTime = 3000;
			else
				self.bcreateMode = false;
				self.printMessage = "Stopped Recording";
				self.nPrintTime = 3000;
			end; 
		end; 
		if isDown and sym == Input.KEY_down and bitAND(modifier, Input.MOD_CTRL) > 0 then
			if self.bActive == false then 
				self.bActive = true; 
				self.bcreateMode = false;
				--self.onStartAiVehicle();
				--self.isHired = true;
				self.forceIsActive = true;
				self.stopMotorOnLeave = false;
				self.disableCharacterOnLeave = false;
				
				self.printMessage = "Activated AutoDrive";
				self.nPrintTime = 3000;
			else
				self.bActive = false; 
				--self.onStopAiVehicle();
				--self.isHired = false;
				self.forceIsActive = false;
				self.stopMotorOnLeave = true;
				self.disableCharacterOnLeave = true;
				
				self.bInitialized = false;
				self.nCurrentWayPoint = 0;
				self.bDrivingForward = true;
				if self.steeringEnabled == false then
					self.steeringEnabled = true;
				end				
				self.printMessage = "Deactivated AutoDrive";
				self.nPrintTime = 3000;
			end; 
		end; 
	end;
	if self == g_currentMission.controlledVehicle then
		
		if isDown and sym == Input.KEY_up and bitAND(modifier, Input.MOD_ALT) > 0 then 
			if self.bCreateMapPoints == false then
				self.bCreateMapPoints = true;
				self.printMessage = "Recording Map Points now - Warning. Only for Developers. Press Alt+Arrow up to stop this";
				self.nPrintTime = 10000;
			else
				self.bCreateMapPoints = false;
				self.printMessage = "Disabled Recording Map Points";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if isDown and sym == Input.KEY_right and bitAND(modifier, Input.MOD_ALT) > 0 then 
			if self.bShowDebugMapMarker == false then
				self.bShowDebugMapMarker = true;
				self.printMessage = "Showing Debug Marker- Deactivate with alt+arrow right";
				self.nPrintTime = 10000;
			else
				self.bShowDebugMapMarker = false;
				self.printMessage = "Disabled Debug Arrows";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if isDown and sym == Input.KEY_down and bitAND(modifier, Input.MOD_ALT) > 0 then 
			if self.bShowSelectedDebugPoint == false then
				self.bShowSelectedDebugPoint = true;
				
				local debugCounter = 1;
				for i,point in pairs(g_currentMission.AutoDrive.mapWayPoints) do
					local x1,y1,z1 = getWorldTranslation(self.components[1].node);
					local distance = getDistance(point.x,point.z,x1,z1);
					
					if distance < 15 then
						self.DebugPointsIterated[debugCounter] = point;
						debugCounter = debugCounter + 1;											
					end;
				end;
				self.nSelectedDebugPoint = 1;
				
				
				self.printMessage = "Showing Debug Point Marker- Deactivate with alt+arrow down";
				self.nPrintTime = 10000;
			else
				self.bShowSelectedDebugPoint = false;
				self.printMessage = "Disabled Debug Point Marker";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if isDown and sym == Input.KEY_left and bitAND(modifier, Input.MOD_ALT) > 0 then 
			if self.bChangeSelectedDebugPoint == false then
				self.bChangeSelectedDebugPoint = true;
				self.printMessage = "Changing entry for highlighted markers";
				self.nPrintTime = 10000;
			else
				self.bChangeSelectedDebugPoint = false;
				self.printMessage = "Not ready";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if isDown and sym == Input.KEY_f and bitAND(modifier, Input.MOD_ALT) > 0 then 
			if self.bChangeSelectedDebugPointSelection == false then
				self.bChangeSelectedDebugPointSelection = true;
				--self.printMessage = "Changing entry for highlighted markers";
				--self.nPrintTime = 10000;
			else
				self.bChangeSelectedDebugPointSelection = false;
				--self.printMessage = "Not ready";
				--self.nPrintTime = 3000;
			end;
			
		end; 
	end;
	
	--]]
end; 

function AutoDrive:deactivate(self,stopVehicle)
				--[[
				if stopVehicle == true then
					local x,y,z = getWorldTranslation( self.components[1].node );
					local xl,yl,zl = worldToLocal(self.components[1].node, self.nTargetX,y,self.nTargetZ);
					AIVehicleUtil.driveToPoint(self, dt, 0, true, self.bDrivingForward, xl, zl, 0, false );
					self:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
				end;
				--]]
				self.bActive = false; 
				self.forceIsActive = false;
				self.stopMotorOnLeave = true;
				self.disableCharacterOnLeave = true;
								
				self.bInitialized = false;
				self.nCurrentWayPoint = 0;
				self.bDrivingForward = true;
				if self.steeringEnabled == false then
					self.steeringEnabled = true;
				end				
				
				self.printMessage = "Deactivated AutoDrive";
				self.nPrintTime = 3000;
end;

function AutoDrive:update(dt) 
	
	if self == g_currentMission.controlledVehicle then
		if InputBinding.hasEvent(InputBinding.ADSilomode) then
			if self.bReverseTrack == false then
				self.bReverseTrack = true;
				self.bTargetMode = false;
				self.nSpeed = 15;
				--print("reverse track = true");
				self.printMessage = "Set to Silomode";
				self.nPrintTime = 3000;
			else
				self.bReverseTrack = false;	
				self.bDrivingForward = true;
				--print("reverse track = false");
				self.printMessage = "Disabled Silomode";
				self.nPrintTime = 3000;
			end;			
			
			AutoDriveInputEvent:sendEvent(self)
			
		end;
		if InputBinding.hasEvent(InputBinding.ADRoundtrip) then
			if self.bRoundTrip == false then
				self.bRoundTrip = true;
				self.nSpeed = 40;
				self.bTargetMode = false;
				--print("roundTrip = true");
				self.printMessage = "Activated Round Trip";
				self.nPrintTime = 3000;
				
			else
				self.bRoundTrip = false;
				--print("roundTrip = false");
				self.printMessage = "Deactivated Round Trip";
				self.nPrintTime = 3000;
			end;
			
			
			AutoDriveInputEvent:sendEvent(self)
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADRecord) then
			if self.bcreateMode == false then 
				self.bcreateMode = true;				
				self.nCurrentWayPoint = 0;
				self.bActive = false;
				self.ad.wayPoints = {};
				self.bTargetMode = false;
				self.printMessage = "Activated Recording Mode";
				self.nPrintTime = 3000;
			else
				self.bcreateMode = false;
				self.printMessage = "Stopped Recording";
				self.nPrintTime = 3000;
			end; 
			
			
			AutoDriveInputEvent:sendEvent(self)
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADEnDisable) then
			if self.bActive == false then 
				self.bActive = true; 
				self.bcreateMode = false;
				--self.onStartAiVehicle();
				--self.isHired = true;
				self.forceIsActive = true;
				self.stopMotorOnLeave = false;
				self.disableCharacterOnLeave = true;
				
				self.printMessage = "Activated AutoDrive";
				self.nPrintTime = 3000;
			else
				self.bStopAD = true;
				--AutoDrive:deactivate(self,false);
			end; 
			
			AutoDriveInputEvent:sendEvent(self)
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADSelectTarget) then
			if self.nMapMarkerSelected == -1 then
				self.nMapMarkerSelected = 1				
					
				self.ntargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].id;
				self.nSpeed = 40;
				self.sTargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.printMessage = "Selected Target: ".. g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nPrintTime = 3000;
				self.bTargetMode = true;
				
			else
				self.nMapMarkerSelected = self.nMapMarkerSelected + 1;	
				if self.nMapMarkerSelected > g_currentMission.AutoDrive.mapMarkerCounter then
					self.nMapMarkerSelected = 1;
				end;
				self.ntargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].id;				
				self.sTargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nSpeed = 40;
				self.printMessage = "Selected Target: ".. g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nPrintTime = 3000;
				self.bTargetMode = true;
			end;
			
			AutoDriveInputEvent:sendEvent(self)
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADSelectPreviousTarget) then
			if self.nMapMarkerSelected == -1 then
				self.nMapMarkerSelected = g_currentMission.AutoDrive.mapMarkerCounter;				
					
				self.ntargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].id;
				self.nSpeed = 40;
				self.sTargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.printMessage = "Selected Target: ".. g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nPrintTime = 3000;
				self.bTargetMode = true;
				
			else
				self.nMapMarkerSelected = self.nMapMarkerSelected - 1;	
				if self.nMapMarkerSelected < 1 then
					self.nMapMarkerSelected = g_currentMission.AutoDrive.mapMarkerCounter;	
				end;
				self.ntargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].id;				
				self.sTargetSelected = g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nSpeed = 40;
				self.printMessage = "Selected Target: ".. g_currentMission.AutoDrive.mapMarker[self.nMapMarkerSelected].name;
				self.nPrintTime = 3000;
				self.bTargetMode = true;
			end;
			
			AutoDriveInputEvent:sendEvent(self)
			
		end;
		
		if InputBinding.hasEvent(InputBinding.ADActivateDebug)  then 
			if self.bCreateMapPoints == false then
				self.bCreateMapPoints = true;
				self.printMessage = "Recording Map Points now - Warning. Only for Developers. Press Alt+Arrow up to stop this";
				self.nPrintTime = 10000;
			else
				self.bCreateMapPoints = false;
				self.printMessage = "Disabled Recording Map Points";
				self.nPrintTime = 3000;
			end;
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADDebugShowClosest)  then 
			if self.bShowDebugMapMarker == false then
				self.bShowDebugMapMarker = true;
				self.printMessage = "Showing Debug Marker- Deactivate with alt+arrow right";
				self.nPrintTime = 10000;
			else
				self.bShowDebugMapMarker = false;
				self.printMessage = "Disabled Debug Arrows";
				self.nPrintTime = 3000;
			end;
			
		end; 
		
		if InputBinding.hasEvent(InputBinding.ADDebugSelectNeighbor) then 
			if self.bShowSelectedDebugPoint == false then
				self.bShowSelectedDebugPoint = true;
				
				local debugCounter = 1;
				for i,point in pairs(g_currentMission.AutoDrive.mapWayPoints) do
					local x1,y1,z1 = getWorldTranslation(self.components[1].node);
					local distance = getDistance(point.x,point.z,x1,z1);
					
					if distance < 15 then
						self.DebugPointsIterated[debugCounter] = point;
						debugCounter = debugCounter + 1;											
					end;
				end;
				self.nSelectedDebugPoint = 1;
				
				
				self.printMessage = "Showing Debug Point Marker- Deactivate with alt+arrow down";
				self.nPrintTime = 10000;
			else
				self.bShowSelectedDebugPoint = false;
				self.printMessage = "Disabled Debug Point Marker";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if InputBinding.hasEvent(InputBinding.ADDebugCreateConnection) then 
			if self.bChangeSelectedDebugPoint == false then
				self.bChangeSelectedDebugPoint = true;
				self.printMessage = "Changing entry for highlighted markers";
				self.nPrintTime = 10000;
			else
				self.bChangeSelectedDebugPoint = false;
				self.printMessage = "Not ready";
				self.nPrintTime = 3000;
			end;
			
		end; 
		if InputBinding.hasEvent(InputBinding.ADDebugChangeNeighbor) then 
			if self.bChangeSelectedDebugPointSelection == false then
				self.bChangeSelectedDebugPointSelection = true;
				--self.printMessage = "Changing entry for highlighted markers";
				--self.nPrintTime = 10000;
			else
				self.bChangeSelectedDebugPointSelection = false;
				--self.printMessage = "Not ready";
				--self.nPrintTime = 3000;
			end;
			
		end; 
		
		
	end;
	
	if self.moduleInitialized == nil then
		init(self);
	end;
	
	if self.bActive == true then
		self.forceIsActive = true;
		self.stopMotorOnLeave = false;
		self.disableCharacterOnLeave = true;
	else
		self.forceIsActive = false;
		self.stopMotorOnLeave = true;
	end;
		
	
	if self.printMessage ~= nil then
		self.nPrintTime = self.nPrintTime - dt;
		if self.nPrintTime < 0 then
			self.nPrintTime = 3000;
			self.printMessage = nil;
		end;
	end;
	
	--set target waypoint and create route
	--follow next waypoint until close enough (0.5m?), then select next waypoint
	--stop vehicle on arrival
	
	
	local veh = self;
	
	--follow waypoints on route:
	
	if self.bStopAD == true then
		AutoDrive:deactivate(self,false);
		self.bStopAD = false;
	end;
	
	if self.components ~= nil then
	
		local x,y,z = getWorldTranslation( self.components[1].node );
		local xl,yl,zl = worldToLocal(veh.components[1].node, x,y,z);
			
			if self.bActive == true then
				if self.steeringEnabled then
					self.steeringEnabled = false;
				end
				
				if self.bInitialized == false then
					if self.bTargetMode == true then
						local closest = AutoDrive:findClosestWayPoint(veh);
						--print("closest wp: " .. closest);
						--AutoDrive:dijkstra(g_currentMission.AutoDrive.mapWayPoints,closest, "out");
						--self.ad.wayPoints = AutoDrive:shortestPath(g_currentMission.AutoDrive.mapWayPoints,self.ad.distance,self.ad.pre,closest,self.ntargetSelected);
						self.ad.wayPoints = AutoDrive:FastShortestPath(g_currentMission.AutoDrive.mapWayPoints, closest, self.sTargetSelected, self.ntargetSelected);
						
					end;
					
					self.nCurrentWayPoint = 3;-- 1;
					
					if self.ad.wayPoints[self.nCurrentWayPoint] ~= nil then
						self.nTargetX = self.ad.wayPoints[self.nCurrentWayPoint].x;
						self.nTargetZ = self.ad.wayPoints[self.nCurrentWayPoint].z;
						self.bInitialized = true;
						self.bDrivingForward = true;
					else
						print("Autodrive hat ein Problem festgestellt");
						AutoDrive:deactivate(self,true);
					end;
				else
					if veh == g_currentMission.controlledVehicle then
						--self.printMessage = "wp 1: " .. self.ad.wayPoints[1].id;
						--self.nPrintTime = 3000;
					end;
					if getDistance(x,z, self.nTargetX, self.nTargetZ) < 1.4 then
						
						if self.ad.wayPoints[self.nCurrentWayPoint+1] ~= nil then
							self.nCurrentWayPoint = self.nCurrentWayPoint + 1;
							self.nTargetX = self.ad.wayPoints[self.nCurrentWayPoint].x;
							self.nTargetZ = self.ad.wayPoints[self.nCurrentWayPoint].z;
							
							
						else
							--print("Last waypoint reached");
							if self.bRoundTrip == false then
								--print("No Roundtrip");
								if self.bReverseTrack == true then
									--print("Starting reverse track");
									--reverse driving direction
									if self.bDrivingForward == true then
										self.bDrivingForward = false;
									else
										self.bDrivingForward = true;
									end;
									--reverse waypoints
									local reverseWaypoints = {};
									local _counterWayPoints = 0;
									for n in pairs(self.ad.wayPoints) do
										_counterWayPoints = _counterWayPoints + 1;
									end;
									for n in pairs(self.ad.wayPoints) do
										reverseWaypoints[_counterWayPoints] = self.ad.wayPoints[n];
										_counterWayPoints = _counterWayPoints - 1;
									end;
									for n in pairs(reverseWaypoints) do
										self.ad.wayPoints[n] = reverseWaypoints[n];
									end;
									--start again:
									self.nCurrentWayPoint = 1
									self.nTargetX = self.ad.wayPoints[self.nCurrentWayPoint].x;
									self.nTargetZ = self.ad.wayPoints[self.nCurrentWayPoint].z;
									
								else				
									--print("Shutting down");
									
									if self.isServer == true then
										xl,yl,zl = worldToLocal(veh.components[1].node, self.nTargetX,y,self.nTargetZ);
										
										AIVehicleUtil.driveToPoint(self, dt, 0, true, self.bDrivingForward, xl, zl, 0, false );
										
										veh:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
									end;
									
									veh:setCruiseControlState(Drivable.CRUISECONTROL_STATE_OFF);
									
									AutoDrive:deactivate(self,true);
								end;
							else	
								--print("Going into next round");
								self.nCurrentWayPoint = 1
								if self.ad.wayPoints[self.nCurrentWayPoint] ~= nil then
									self.nTargetX = self.ad.wayPoints[self.nCurrentWayPoint].x;
									self.nTargetZ = self.ad.wayPoints[self.nCurrentWayPoint].z;
									
								else
									print("Autodrive hat ein Problem festgestellt");
									AutoDrive:deactivate(self,true);
								end;
							end;
						end;
					end;
						
				end;
				
				
				if self.bActive == true then
					if self.isServer == true then
						if self.ad.wayPoints[self.nCurrentWayPoint+1] ~= nil then
							--AutoDrive:addlog("Issuing Drive Request");
							xl,yl,zl = worldToLocal(veh.components[1].node, self.nTargetX,y,self.nTargetZ);
							AIVehicleUtil.driveToPoint(self, dt, 1, true, self.bDrivingForward, xl, zl, self.nSpeed, false );
						else
							--print("Reaching last waypoint - slowing down");
							xl,yl,zl = worldToLocal(veh.components[1].node, self.nTargetX,y,self.nTargetZ);
							AIVehicleUtil.driveToPoint(self, dt, 1, true, self.bDrivingForward, xl, zl, 5, false );
						end;
					end;
				end;
			end;
		
		veh.aiSteeringSpeed = 1;
		--print(" target: " .. self.nTargetX .. "/" .. self.nTargetZ .. " steeringSpeed: " .. veh.aiSteeringSpeed);
	end;
	
	if veh == g_currentMission.controlledVehicle then
		if veh ~= nil then
			--manually create waypoints in create-mode:
			if self.bcreateMode == true then
				--record waypoints every 6m
				local i = 0;
				for n in pairs(self.ad.wayPoints) do 
					i = i+1;
				end;
				i = i+1;
				
				--first entry
				if i == 1 then
					local x1,y1,z1 = getWorldTranslation(veh.components[1].node);
					self.ad.wayPoints[i] = createVector(x1,y1,z1);
					
					if self.bCreateMapPoints == true then
						AutoDrive:MarkChanged();
						g_currentMission.AutoDrive.mapWayPointsCounter = g_currentMission.AutoDrive.mapWayPointsCounter + 1;
						g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter] = createNode(g_currentMission.AutoDrive.mapWayPointsCounter,{},{},{},{});
						g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].x = x1;
						g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].y = y1;
						g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].z = z1;
						
						print("Creating Waypoint #" .. g_currentMission.AutoDrive.mapWayPointsCounter);
							
					end;
					
					i = i+1;
				else
					local x,y,z = getWorldTranslation(veh.components[1].node);
					local wp = self.ad.wayPoints[i-1];
					if getDistance(x,z,wp.x,wp.z) > 6 then
						self.ad.wayPoints[i] = createVector(x,y,z);
						if self.bCreateMapPoints == true then
							g_currentMission.AutoDrive.mapWayPointsCounter = g_currentMission.AutoDrive.mapWayPointsCounter + 1;
							--edit previous point
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter-1].out[1] = g_currentMission.AutoDrive.mapWayPointsCounter;
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter-1].out_cost[1] = 1;
							--edit current point
							print("Creating Waypoint #" .. g_currentMission.AutoDrive.mapWayPointsCounter);
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter] = createNode(g_currentMission.AutoDrive.mapWayPointsCounter,{},{},{},{});						
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].incoming[1] = g_currentMission.AutoDrive.mapWayPointsCounter-1;
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].x = x;
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].y = y;
							g_currentMission.AutoDrive.mapWayPoints[g_currentMission.AutoDrive.mapWayPointsCounter].z = z;
						end;
						
						i = i+1;		
					end;
				end;
				
				--[[				
				counter = 1;	
				for n in pairs(self.ad.wayPoints) do
				
					AutoDrive:addlog("waypoint " .. counter .. " " .. self.ad.wayPoints[n].x .. "/" .. self.ad.wayPoints[n].y .. "/" .. self.ad.wayPoints[n].z);
					counter = counter +1;
				end;
				AutoDrive:addlog("eol");
				--]]
				

			end;
		end;	
	end;
	
	if self.isServer == true then
		AutoDriveInputEvent:sendEvent(self);
	end;
	
	--AutoDrive:log(dt);
end;

function AutoDrive:log(dt)
	
	self.nlastLogged = self.nlastLogged + dt;
	if self.nlastLogged >= self.nloggingInterval then
		self.nlastLogged = self.nlastLogged - self.nloggingInterval;
		if self.logMessage ~= "" then
			print(self.logMessage);
			self.logMessage = "";
		end;
	end;
	
end;

function AutoDrive:addlog(text)
	--[[
	if string.find(self.logMessage, text) == nil then
		self.logMessage = self.logMessage .. text .. "\n";
	end;
	--]]
	self.logMessage = text;
end;

function createVector(x,y,z)
	local table t = {};
	t["x"] = x;
	t["y"] = y;
	t["z"] = z;
	return t; 
end;

function getDistance(x1,z1,x2,z2)
	return math.sqrt((x1-x2)*(x1-x2) + (z1-z2)*(z1-z2) );
end;

function readWayPoints()
	--read xmlFile
	--unique for each map
	--waypoints are ordered in a bidirectional graph
end;

function findWay(startWayPointID, targetWayPointID)
	--graph algorithm to find shortest path towards target
	--return list of waypoints
end;

function AutoDrive:findClosestWayPoint(veh)
	--returns waypoint closest to vehicle position
	local x1,y1,z1 = getWorldTranslation(veh.components[1].node);
	
	local closest = 1;
	local distance = getDistance(g_currentMission.AutoDrive.mapWayPoints[1].x,g_currentMission.AutoDrive.mapWayPoints[1].z,x1,z1);
	for i in pairs(g_currentMission.AutoDrive.mapWayPoints) do
		local dis = getDistance(g_currentMission.AutoDrive.mapWayPoints[i].x,g_currentMission.AutoDrive.mapWayPoints[i].z,x1,z1);
		if dis < distance then
			closest = i;
			distance = dis;
		end;
	end;
	
	return closest;
end;


function AutoDrive:draw() 
	
	if self.nCurrentWayPoint > 0 then
		if self.ad.wayPoints[self.nCurrentWayPoint+1] ~= nil then
			--print("drawing debug line");
			drawDebugLine(self.ad.wayPoints[self.nCurrentWayPoint].x, self.ad.wayPoints[self.nCurrentWayPoint].y+4, self.ad.wayPoints[self.nCurrentWayPoint].z, 0,1,1, self.ad.wayPoints[self.nCurrentWayPoint+1].x, self.ad.wayPoints[self.nCurrentWayPoint+1].y+4, self.ad.wayPoints[self.nCurrentWayPoint+1].z, 1,1,1);
		end;
		if self.ad.wayPoints[self.nCurrentWayPoint-1] ~= nil then
			drawDebugLine(self.ad.wayPoints[self.nCurrentWayPoint-1].x, self.ad.wayPoints[self.nCurrentWayPoint-1].y+4, self.ad.wayPoints[self.nCurrentWayPoint-1].z, 0,1,1, self.ad.wayPoints[self.nCurrentWayPoint].x, self.ad.wayPoints[self.nCurrentWayPoint].y+4, self.ad.wayPoints[self.nCurrentWayPoint].z, 1,1,1);
				
		end;
	end;
	if self.bcreateMode == true then
		local _drawCounter = 1;
		for n in pairs(self.ad.wayPoints) do
			if self.ad.wayPoints[n+1] ~= nil then
				drawDebugLine(self.ad.wayPoints[n].x, self.ad.wayPoints[n].y+4, self.ad.wayPoints[n].z, 0,1,1, self.ad.wayPoints[n+1].x, self.ad.wayPoints[n+1].y+4, self.ad.wayPoints[n+1].z, 1,1,1);
			else
				drawDebugLine(self.ad.wayPoints[n].x, self.ad.wayPoints[n].y+4, self.ad.wayPoints[n].z, 0,1,1, self.ad.wayPoints[n].x, self.ad.wayPoints[n].y+5, self.ad.wayPoints[n].z, 1,1,1);
			end;
		end;
	end;
	
	if self.bCreateMapPoints == true then
		if self == g_currentMission.controlledVehicle then
			for i,point in pairs(g_currentMission.AutoDrive.mapWayPoints) do
				local x1,y1,z1 = getWorldTranslation(self.components[1].node);
				local distance = getDistance(point.x,point.z,x1,z1);
				if distance < 50 then

					if point.out ~= nil then
						for i2,neighbor in pairs(point.out) do
							drawDebugLine(point.x, point.y+4, point.z, 0,1,1, g_currentMission.AutoDrive.mapWayPoints[neighbor].x, g_currentMission.AutoDrive.mapWayPoints[neighbor].y+4, g_currentMission.AutoDrive.mapWayPoints[neighbor].z, 1,1,1);
						end;
					end;
					
				end;
			end;
			
			if self.bShowDebugMapMarker == true then
				local closest = AutoDrive:findClosestWayPoint(self);
				local x1,y1,z1 = getWorldTranslation(self.components[1].node);
				drawDebugLine(x1, y1, z1, 1,1,1, g_currentMission.AutoDrive.mapWayPoints[closest].x, g_currentMission.AutoDrive.mapWayPoints[closest].y+4, g_currentMission.AutoDrive.mapWayPoints[closest].z, 1,1,1);
				
				if self.printMessage == nil then
					self.printMessage = "Closest Waypoint: "..closest;
					self.nPrintTime = 6000;
				end;
				
				if self.bShowSelectedDebugPoint == true then
					if self.DebugPointsIterated[self.nSelectedDebugPoint] ~= nil then
						
						drawDebugLine(x1, y1, z1, 1,1,1, self.DebugPointsIterated[self.nSelectedDebugPoint].x, self.DebugPointsIterated[self.nSelectedDebugPoint].y+4, self.DebugPointsIterated[self.nSelectedDebugPoint].z, 1,1,1);
					else
						self.nSelectedDebugPoint = 1;
					end;
					
					if self.bChangeSelectedDebugPoint == true then
						
						local out_counter = 1;
						local exists = false;
						for i in pairs(g_currentMission.AutoDrive.mapWayPoints[closest].out) do
							if exists == true then
								--print ("Entry exists "..i.. " out_counter: "..out_counter);
								g_currentMission.AutoDrive.mapWayPoints[closest].out[out_counter] = g_currentMission.AutoDrive.mapWayPoints[closest].out[i];
								g_currentMission.AutoDrive.mapWayPoints[closest].out_cost[out_counter] = g_currentMission.AutoDrive.mapWayPoints[closest].out_cost[i];
								out_counter = out_counter +1;
							else
								if g_currentMission.AutoDrive.mapWayPoints[closest].out[i] == self.DebugPointsIterated[self.nSelectedDebugPoint].id then
									g_currentMission.AutoDrive.mapWayPoints[closest].out[i] = nil;
									g_currentMission.AutoDrive.mapWayPoints[closest].out_cost[i] = nil;
									exists = true;
								else							
									out_counter = out_counter +1;
								end;
							end;							
						end;
						
						if exists == false then
							g_currentMission.AutoDrive.mapWayPoints[closest].out[out_counter] = self.DebugPointsIterated[self.nSelectedDebugPoint].id;
							g_currentMission.AutoDrive.mapWayPoints[closest].out_cost[out_counter] = 1;
						end;
						
						
						self.bChangeSelectedDebugPoint = false;
					
					end;
					
					if self.bChangeSelectedDebugPointSelection == true then
						self.nSelectedDebugPoint = self.nSelectedDebugPoint + 1;
						self.bChangeSelectedDebugPointSelection = false;
					end;
				end;				
			end;	
		end;		
	end;
	
	
	if self == g_currentMission.controlledVehicle then
		if self.printMessage ~= nil then
			local adFontSize = 0.014;
			local adPosX = 0.03 + g_currentMission.helpBoxWidth
			local adPosY = 0.975;
			renderText(adPosX, adPosY, adFontSize, self.printMessage);
			--self.printMessage = nil;
		end;
	end;
	
end; 

function AutoDrive:removeMapWayPoint(id)
			
--ToDO
end;


function getFillType_new(fillType, implementTypeName)
	local sFillType = g_i18n:getText("UNKNOWN"); 
	
	if FillUtil.fillTypeIndexToDesc[fillType] ~= nil then
		output1 =  FillUtil.fillTypeIndexToDesc[fillType].nameI18N
		if string.find(output1, "Missing") then
			sFillType = g_i18n:getText("UNKNOWN"); 
		else
			sFillType = output1;
		end;
	end;
	
	return sFillType;
end; 

function round(num, idp) 
	if Utils.getNoNil(num, 0) > 0 then 
		local mult = 10^(idp or 0); 
		return math.floor(num * mult + 0.5) / mult; 
	else 
		return 0; 
	end; 
end; 

function getPercentage(capacity, level) 
	return level / capacity * 100; 
end;
 
addModEventListener(AutoDrive);

--InputEvent%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--InputEvent%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
--InputEvent%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


AutoDriveInputEvent = {};
AutoDriveInputEvent_mt = Class(AutoDriveInputEvent, Event);

InitEventClass(AutoDriveInputEvent, "AutoDriveInputEvent");

function AutoDriveInputEvent:emptyNew()
    local self = Event:new(AutoDriveInputEvent_mt);
    self.className="AutoDriveInputEvent";
    return self;
end;

function AutoDriveInputEvent:new(vehicle)
    local self = AutoDriveInputEvent:emptyNew()
    self.vehicle = vehicle;
	
	self.bActive = vehicle.bActive;
	self.bRoundTrip = vehicle.bRoundTrip;
	self.bReverseTrack = vehicle.bReverseTrack;
	self.bDrivingForward = vehicle.bDrivingForward;
	self.nTargetX = vehicle.nTargetX;
	self.nTargetZ = vehicle.nTargetZ;
	self.bInitialized = vehicle.bInitialized;
	self.wayPoints = vehicle.ad.wayPoints;
	self.bcreateMode = vehicle.bcreateMode;
	self.nCurrentWayPoint = vehicle.nCurrentWayPoint;
	self.nlastLogged = vehicle.nlastLogged;
	self.nloggingInterval = vehicle.nloggingInterval;
	self.logMessage = vehicle.logMessage;
	self.nPrintTime = vehicle.nPrintTime;
	self.ntargetSelected = vehicle.ntargetSelected;
	self.bTargetMode = vehicle.bTargetMode;
	self.nMapMarkerSelected = vehicle.nMapMarkerSelected;
	self.nSpeed = vehicle.nSpeed;
	self.bCreateMapPoints = vehicle.bCreateMapPoints;
	self.bShowDebugMapMarker = vehicle.bShowDebugMapMarker;
	self.nSelectedDebugPoint = vehicle.nSelectedDebugPoint;
	self.bShowSelectedDebugPoint = vehicle.bShowSelectedDebugPoint;
	self.bChangeSelectedDebugPoint = vehicle.bChangeSelectedDebugPoint;
	self.DebugPointsIterated = vehicle.DebugPointsIterated;
	self.sTargetSelected = vehicle.sTargetSelected;
	self.bStopAD = vehicle.bStopAD;
	
	--print("event new")
    return self;
end;

function AutoDriveInputEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	
	streamWriteBool(streamId, self.bActive);
	streamWriteBool(streamId, self.bRoundTrip);
	streamWriteBool(streamId, self.bReverseTrack);
	streamWriteBool(streamId, self.bDrivingForward);
	
	streamWriteFloat32(streamId, self.nTargetX);
	streamWriteFloat32(streamId, self.nTargetZ);
	
	streamWriteBool(streamId, self.bInitialized);
	
	self.wayPointsString = "";
	for i, point in pairs(self.wayPoints) do 
		if self.wayPointsString == "" then
			self.wayPointsString = self.wayPointsString .. point.id;
		else
			self.wayPointsString = self.wayPointsString .. "," .. point.id;
		end;
	end;
	streamWriteString(streamId, self.wayPointsString);
		
	streamWriteBool(streamId, self.bcreateMode);
	streamWriteFloat32(streamId, self.nCurrentWayPoint);
	streamWriteFloat32(streamId, self.nlastLogged);
	streamWriteFloat32(streamId, self.nloggingInterval);
	streamWriteString(streamId, self.logMessage);
	streamWriteFloat32(streamId, self.nPrintTime);
	streamWriteFloat32(streamId, self.ntargetSelected);
	streamWriteBool(streamId, self.bTargetMode);
	streamWriteFloat32(streamId, self.nMapMarkerSelected);
	streamWriteFloat32(streamId, self.nSpeed);
	streamWriteBool(streamId, self.bCreateMapPoints);
	streamWriteBool(streamId, self.bShowDebugMapMarker);
	streamWriteFloat32(streamId, self.nSelectedDebugPoint);
	streamWriteBool(streamId, self.bShowSelectedDebugPoint);
	streamWriteBool(streamId, self.bChangeSelectedDebugPoint);
	
	self.debugPointsIteratedString = "";
	for i, point in pairs(self.DebugPointsIterated) do 
		if self.debugPointsIteratedString == "" then
			self.debugPointsIteratedString = debugPointsIteratedString .. point.id;
		else
			
			self.debugPointsIteratedString = debugPointsIteratedString .. "," .. point.id;
		end;
	end;
	streamWriteString(streamId, self.debugPointsIteratedString);
	
	
	streamWriteString(streamId, self.sTargetSelected);	
	streamWriteBool(streamId, self.bStopAD);
	
	-- print("event writeStream")
end;

function AutoDriveInputEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    local vehicle = networkGetObject(id);
	
	local bActive = streamReadBool(streamId);
	local bRoundTrip = streamReadBool(streamId);
	local bReverseTrack = streamReadBool(streamId);
	local bDrivingForward = streamReadBool(streamId);
	local nTargetX = streamReadFloat32(streamId);
	local nTargetZ = streamReadFloat32(streamId);
	local bInitialized = streamReadBool(streamId);
	
	local wayPointsString = streamReadString(streamId);
	local wayPointID = Utils.splitString(",", wayPointsString);
	local wayPoints = {};
	for i,id in pairs(wayPointID) do
		wayPoints[i] = g_currentMission.AutoDrive.mapWayPoints[id];
	end;
	
	local bcreateMode = streamReadBool(streamId);
	local nCurrentWayPoint = streamReadFloat32(streamId);
	local nlastLogged = streamReadFloat32(streamId);
	local nloggingInterval = streamReadFloat32(streamId);
	local logMessage = streamReadString(streamId);
	local nPrintTime = streamReadFloat32(streamId);
	local ntargetSelected = streamReadFloat32(streamId);
	local bTargetMode = streamReadBool(streamId);
	local nMapMarkerSelected = streamReadFloat32(streamId);
	local nSpeed = streamReadFloat32(streamId);
	local bCreateMapPoints = streamReadBool(streamId);
	local bShowDebugMapMarker = streamReadBool(streamId);
	local nSelectedDebugPoint = streamReadFloat32(streamId);
	local bShowSelectedDebugPoint = streamReadBool(streamId);
	local bChangeSelectedDebugPoint = streamReadBool(streamId);
	
	local DebugPointsIteratedString = streamReadString(streamId);
	local DebugPointsID = Utils.splitString(",", DebugPointsIteratedString);
	local DebugPointsIterated = {};
	for i,id in pairs(DebugPointsID) do
		DebugPointsID[i] = g_currentMission.AutoDrive.mapWayPoints[id];
	end;
	
	local sTargetSelected = streamReadString(streamId);
	local bStopAD = streamReadBool(streamId);
		
	vehicle.bActive = bActive;
	vehicle.bRoundTrip = bRoundTrip;
	vehicle.bReverseTrack = bReverseTrack ;
	vehicle.bDrivingForward = bDrivingForward;
	vehicle.nTargetX = nTargetX ;
	vehicle.nTargetZ = nTargetZ;
	vehicle.bInitialized = bInitialized;
	vehicle.ad.wayPoints = wayPoints ;
	vehicle.bcreateMode = bcreateMode;
	vehicle.nCurrentWayPoint = nCurrentWayPoint ;
	vehicle.nlastLogged = nlastLogged;
	vehicle.nloggingInterval = nloggingInterval;
	vehicle.logMessage = logMessage;
	vehicle.nPrintTime = nPrintTime;
	vehicle.ntargetSelected = ntargetSelected;
	vehicle.bTargetMode = bTargetMode;
	vehicle.nMapMarkerSelected = nMapMarkerSelected ;
	vehicle.nSpeed = nSpeed;
	vehicle.bCreateMapPoints = bCreateMapPoints;
	vehicle.bShowDebugMapMarker = bShowDebugMapMarker;
	vehicle.nSelectedDebugPoint = nSelectedDebugPoint;
	vehicle.bShowSelectedDebugPoint = bShowSelectedDebugPoint;
	vehicle.bChangeSelectedDebugPoint = bChangeSelectedDebugPoint;
	vehicle.DebugPointsIterated = DebugPointsIterated ;
	vehicle.sTargetSelected = sTargetSelected;	
	vehicle.bStopAD = bStopAD;
		
	if g_server ~= nil then	
		g_server:broadcastEvent(AutoDriveInputEvent:new(vehicle), nil, nil, vehicle);
		-- print("broadcasting")
	end;
end;

function AutoDriveInputEvent:sendEvent(vehicle)
	if g_server ~= nil then	
		g_server:broadcastEvent(AutoDriveInputEvent:new(vehicle), nil, nil, vehicle);
		-- print("broadcasting")
	else
		g_client:getServerConnection():sendEvent(AutoDriveInputEvent:new(vehicle));
		-- print("sending event to server...")
	end;
end;

